com.fasterxml.jackson.databind.deser.std

## Class FromStringDeserializer.Std

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<T>
      - - com.fasterxml.jackson.databind.deser.std.FromStringDeserializer<Object>
        - - com.fasterxml.jackson.databind.deser.std.FromStringDeserializer.Std

All Implemented Interfaces:
  NullValueProvider, ValueInstantiator.Gettable, Serializable

Enclosing class:
  FromStringDeserializer<T>

    public static class FromStringDeserializer.Std
    extends FromStringDeserializer<Object>

"Chameleon" deserializer that works on simple types that are deserialized from a simple String.

Since:
  2.4
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.deser.std.FromStringDeserializer

`FromStringDeserializer.Std`

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected int` `_kind`
`protected static String` `LOCALE_EXT_MARKER`
`static int` `STD_CHARSET`
`static int` `STD_CLASS`
`static int` `STD_CURRENCY`
`static int` `STD_FILE`
`static int` `STD_INET_ADDRESS`
`static int` `STD_INET_SOCKET_ADDRESS`
`static int` `STD_JAVA_TYPE`
`static int` `STD_LOCALE`
`static int` `STD_PATTERN`
`static int` `STD_TIME_ZONE`
`static int` `STD_URI`
`static int` `STD_URL`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`protected` `Std(Class<?> valueType, int kind)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected Object` `_deserialize(String value, DeserializationContext ctxt)` Main method from trying to deserialize actual value from non-empty String.
`protected Object` `_deserializeFromEmptyStringDefault(DeserializationContext ctxt)`
`protected int` `_firstHyphenOrUnderscore(String str)`
`protected boolean` `_shouldTrim()`
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.FromStringDeserializer

`_deserializeEmbedded, _deserializeFromEmptyString, _deserializeFromEmptyString, _deserializeFromOther, deserialize, findDeserializer, logicalType, types`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

`deserialize, deserializeWithType, getEmptyAccessPattern, getNullAccessPattern, supportsUpdate`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkBooleanToStringCoercion, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFloatToStringCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkIntToFloatCoercion, _checkIntToStringCoercion, _checkTextualNull, _checkToStringCoercion, _coerceBooleanFromInt, _coercedTypeDesc, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseInteger, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLong, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _parseString, _reportFailedNullCoerce, _shortOverflow, _streamReadConstraints, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, getValueType, handledType, handleMissingEndArrayForSingle, handleNestedArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserializeWithType, findBackReference, getAbsentValue, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### STD_FILE

    public static final int STD_FILE

See Also:
  Constant Field Values

#### STD_URL

    public static final int STD_URL

See Also:
  Constant Field Values

#### STD_URI

    public static final int STD_URI

See Also:
  Constant Field Values

#### STD_CLASS

    public static final int STD_CLASS

See Also:
  Constant Field Values

#### STD_JAVA_TYPE

    public static final int STD_JAVA_TYPE

See Also:
  Constant Field Values

#### STD_CURRENCY

    public static final int STD_CURRENCY

See Also:
  Constant Field Values

#### STD_PATTERN

    public static final int STD_PATTERN

See Also:
  Constant Field Values

#### STD_LOCALE

    public static final int STD_LOCALE

See Also:
  Constant Field Values

#### STD_CHARSET

    public static final int STD_CHARSET

See Also:
  Constant Field Values

#### STD_TIME_ZONE

    public static final int STD_TIME_ZONE

See Also:
  Constant Field Values

#### STD_INET_ADDRESS

    public static final int STD_INET_ADDRESS

See Also:
  Constant Field Values

#### STD_INET_SOCKET_ADDRESS

    public static final int STD_INET_SOCKET_ADDRESS

See Also:
  Constant Field Values

#### LOCALE_EXT_MARKER

    protected static final String LOCALE_EXT_MARKER

See Also:
  Constant Field Values

#### _kind

    protected final int _kind

### Constructor Detail

#### Std

    protected Std(Class<?> valueType,
                  int kind)

### Method Detail

#### _deserialize

    protected Object _deserialize(String value,
                                  DeserializationContext ctxt)
                           throws IOException

Description copied from class: `FromStringDeserializer`
Main method from trying to deserialize actual value from non-empty String.

Specified by:
  `_deserialize` in class `FromStringDeserializer<Object>`
Throws:
  `IOException`

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `JsonDeserializer<Object>`
Throws:
  `JsonMappingException`

#### _deserializeFromEmptyStringDefault

    protected Object _deserializeFromEmptyStringDefault(DeserializationContext ctxt)
                                                 throws IOException

Overrides:
  `_deserializeFromEmptyStringDefault` in class `FromStringDeserializer<Object>`
Throws:
  `IOException`

#### _shouldTrim

    protected boolean _shouldTrim()

Overrides:
  `_shouldTrim` in class `FromStringDeserializer<Object>`

#### _firstHyphenOrUnderscore

    protected int _firstHyphenOrUnderscore(String str)